/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of ADS.xs. Do not edit this file, edit ADS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "ADS.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <inttypes.h>
#include <linux/i2c-dev.h>
#include <unistd.h>
#include <sys/ioctl.h>

#define BIT_MAX_12 1650
#define BIT_MAX_16 26400

int fetch(int addr, char * dev, char * wbuf1, char * wbuf2, int res){

    uint8_t write_buf[3];
    uint8_t read_buf[2];

    int i2c_file = open(dev, O_RDWR);

    if (i2c_file == -1){
        perror(dev);
        exit(1);
    }
   
    if (ioctl(i2c_file, I2C_SLAVE, addr) < 0){
        perror("failed to acquire bus access and/or talk to slave");
        exit(1);
    }

    write_buf[0] = 1; // set pointer to config register
    write_buf[1] = strtol(wbuf1, NULL, 0);
    write_buf[2] = strtol(wbuf2, NULL, 0);

    read_buf[0]= 0;
    read_buf[1]= 0;
    
    if (write(i2c_file, write_buf, 3) != 3){
        perror("failed to write to the i2c bus");
        exit(1);
    }

    // AND with 10000000 and wait for bit 15 of the config register to go false`
    // This bit stores the "conversion complete" indicator

    while ((read_buf[0] & 0x80) == 0){
        read(i2c_file, read_buf, 2);
    }

    // 0: conversion register
    // 1: configuration register

    write_buf[0] = 0;
    write(i2c_file, write_buf, 1);

    read(i2c_file, read_buf, 2);

    int16_t conversion = read_buf[0] << 8 | read_buf[1];

    if (res == 12){
        conversion = conversion >> 4;
    }
    
    close(i2c_file);

    return conversion;
}

float voltage_c (int addr, char * dev, char * wbuf1, char * wbuf2, int res){
   
    int conversion = fetch(addr, dev, wbuf1, wbuf2, res);
    
    float volts;
     
    if (res == 12){
        volts = (float)conversion * 4.096 / 2048.0;
    }
    else {
        volts = (float)conversion * 4.096 / 32767.0;
    }

    return volts;
}

int raw_c (int addr, char * dev, char * wbuf1, char * wbuf2, int res){
   
    int conversion = fetch(addr, dev, wbuf1, wbuf2, res);

    return conversion;
}

float percent_c (int addr, char * dev, char * wbuf1, char * wbuf2, int res){

    int conversion = fetch(addr, dev, wbuf1, wbuf2, res);

    float percent;

    if (res == 12){
        percent = (float)conversion / BIT_MAX_12 * 100;
    }
    else {
        percent = (float)conversion / BIT_MAX_16 * 100;
    }

    return percent;
}

#line 121 "ADS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 265 "ADS.c"

XS_EUPXS(XS_RPi__ADC__ADS_fetch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__ADC__ADS_fetch)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "addr, dev, wbuf1, wbuf2, res");
    {
	int	addr = (int)SvIV(ST(0))
;
	char *	dev = (char *)SvPV_nolen(ST(1))
;
	char *	wbuf1 = (char *)SvPV_nolen(ST(2))
;
	char *	wbuf2 = (char *)SvPV_nolen(ST(3))
;
	int	res = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = fetch(addr, dev, wbuf1, wbuf2, res);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__ADC__ADS_voltage_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__ADC__ADS_voltage_c)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "addr, dev, wbuf1, wbuf2, res");
    {
	int	addr = (int)SvIV(ST(0))
;
	char *	dev = (char *)SvPV_nolen(ST(1))
;
	char *	wbuf1 = (char *)SvPV_nolen(ST(2))
;
	char *	wbuf2 = (char *)SvPV_nolen(ST(3))
;
	int	res = (int)SvIV(ST(4))
;
	float	RETVAL;
	dXSTARG;

	RETVAL = voltage_c(addr, dev, wbuf1, wbuf2, res);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__ADC__ADS_raw_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__ADC__ADS_raw_c)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "addr, dev, wbuf1, wbuf2, res");
    {
	int	addr = (int)SvIV(ST(0))
;
	char *	dev = (char *)SvPV_nolen(ST(1))
;
	char *	wbuf1 = (char *)SvPV_nolen(ST(2))
;
	char *	wbuf2 = (char *)SvPV_nolen(ST(3))
;
	int	res = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = raw_c(addr, dev, wbuf1, wbuf2, res);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__ADC__ADS_percent_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__ADC__ADS_percent_c)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "addr, dev, wbuf1, wbuf2, res");
    {
	int	addr = (int)SvIV(ST(0))
;
	char *	dev = (char *)SvPV_nolen(ST(1))
;
	char *	wbuf1 = (char *)SvPV_nolen(ST(2))
;
	char *	wbuf2 = (char *)SvPV_nolen(ST(3))
;
	int	res = (int)SvIV(ST(4))
;
	float	RETVAL;
	dXSTARG;

	RETVAL = percent_c(addr, dev, wbuf1, wbuf2, res);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_RPi__ADC__ADS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_RPi__ADC__ADS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("RPi::ADC::ADS::fetch", XS_RPi__ADC__ADS_fetch);
        newXS_deffile("RPi::ADC::ADS::voltage_c", XS_RPi__ADC__ADS_voltage_c);
        newXS_deffile("RPi::ADC::ADS::raw_c", XS_RPi__ADC__ADS_raw_c);
        newXS_deffile("RPi::ADC::ADS::percent_c", XS_RPi__ADC__ADS_percent_c);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

